// https://www.spoj.com/problems/HORRIBLE/
// AC 0.22 sec
#include <stdio.h>
#include <algorithm>
#include <cstring>
using namespace std;

const int N   = 100001,
          MAX = 4 * N + 5;

long long tree[MAX];
long long lz[MAX];
int n;

void Propagate(int x, int l, int r)
{
	if (lz[x] != 0)
  	{
   		tree[x] += (r - l + 1) * lz[x];

		if (l != r)
		{
			lz[2 * x]   += lz[x];
    		lz[2 * x + 1] += lz[x];
		}
   		lz[x] = 0;
  	}
}

void Update(int x, int l, int r, int a, int b, long long value)
{
  	Propagate(x, l, r);
   
  	if (a <= l && r <= b)
  	{
    	lz[x] += value;
		Propagate(x, l, r);
    	return;
	}
	
	if (l > r || l > b || r < a)
        return; 
        
	int m = l + (r - l ) / 2;
	
	Update(2 * x, l, m, a, b, value);
	Update(2 * x + 1, m + 1, r, a, b, value);

	tree[x] = tree[2 * x] + tree[2 * x + 1];
}

long long  Query(int x, int l, int r, int a, int b)
{
	Propagate(x, l, r);
	
	if (a <= l && r <= b)
		return tree[x];
	
	if (l > r || l > b || r < a) return 0; // ok (aici, nu sus)

	int m = l + (r - l ) / 2;
	long long s1 = 0, s2 = 0;
	
	s1 = Query(2 * x, l, m, a, b);
	s2 = Query(2 * x + 1, m + 1, r, a, b);
	return s1 + s2;
}

int main()
{
	int T, C, c, p, q;
	long long v;
	scanf("%d", &T);
	while ( T-- )
	{
		memset(tree, 0, sizeof(tree));
		memset(lz,  0, sizeof(lz));
		scanf("%d %d", &n, &C);
		while ( C--)
		{
			scanf("%d %d %d",  &c, &p, &q);
			if ( c == 0 )
			{
				scanf("%lld", &v);
				Update(1, 1, N, p, q, v);
			}
			else
				printf("%lld\n", Query(1, 1, N, p, q) );
		}
	}

	return 0;
}

