// AC 0.55
// https://www.spoj.com/problems/LITE/
#include <iostream>
using namespace std;

const int MAX_N = 1e5 + 5;
int st[4 * MAX_N];
int lazy[4 * MAX_N];   // lazy[x] = nr de switch-uri pe [l, r]
                       // se reseteaza la 0 la fiecare update pe nodul x

void Propagate(int x, int l, int r)
{
	if (lazy[x] % 2) // numar impar de switch-uri
	{
		st[x] = (r - l + 1) - st[x];
		if (l != r)
		{
			lazy[2 * x]     += lazy[x];
			lazy[2 * x + 1] += lazy[x];
		}	
		lazy[x] = 0;
	}
}

void Update(int x, int l, int r, int a, int b)
{
	Propagate(x, l, r);
 
	if (l >= a && r <= b) 
	{
		lazy[x]++;
		
		Propagate(x, l, r);
		return;
	}
	
	if (l > r || r < a || l > b) return;
	
	int m = (l + r) / 2;
	Update(2 * x, l, m, a, b);
	Update(2 * x + 1, m + 1, r, a, b);
	st[x] = st[2 * x] + st[2 * x + 1];
}

int Query(int x, int l, int r, int a, int b)
{
	Propagate(x, l, r);
	
	if (a <= l && r <= b) 
		return st[x];
	
	if (l > r || l > b || r < a)
		return 0;
		
	int m = (l + r) / 2;
	return Query(2 * x, l, m, a, b) + Query(2 * x + 1, m + 1, r, a, b);
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	
	int q, a, b;
	while (m--)
	{	
		cin >> q >> a >> b;
		if (q) 
			cout << Query(1, 1, n, a, b) << '\n';
		else 
			Update(1, 1, n, a, b);
	}
}

