//https://codeforces.com/blog/entry/18051
// In aceasta varianta, in tabloul a[] indexarea este de la 0
#include <iostream>
#include <vector>
#define ll long long
using namespace std;

void BuildST(vector<int>& st, vector<int> &a, int n)
{
    // atribuim valori frunzelor arborelui de intervale
    for (int i = 0; i < n; i++)
        st[n + i] = a[i];

    // atribuim valori nodurilor interne
    for (int i = n - 1; i >= 1; i--)
        st[i] = min(st[2 * i], st[2 * i + 1]);
}

void Update(vector<int>& st, int pos, int value, int n)
{
    // schimbam indexul la un nod frunza
    pos += n;
    st[pos] = value;

    while (pos > 1)
    {
        pos >>= 1;
        st[pos] = min(st[2 * pos],  st[2 * pos + 1]);
    }
}

int Query(vector<int>& st, int l, int r, int n)
{
    l += n;
    r += n;
    int mi = (int)1e9;

    while (l < r)
    {
        if (l & 1) mi = min(mi, st[l++]);
        if (r & 1) mi = min(mi, st[--r]);

        l >>= 1;
        r >>= 1;
    }
    return mi;
}

int main()
{
    vector<int> a = { 2, 6, 10, 4, 7, 1, 9, 11, 6, 3};
    int n = a.size();


    vector<int> st(2 * n);
    BuildST(st, a, n);

    // minimul in intervalul [l, r]
    int l = 0, r = 5;
    cout << "Minimum in intervalul " << l << ", " << r << " : "<< Query(st, l, r + 1, n) << '\n';

    //  La indexul 9 Updatam valoarea la -1
    int index = 9, value = -1;

    Update(st, index, value, n);

    // minimul in intervalul [l, r]
    l = 7, r = 9;
    cout << "Minimul in intervalul " << l << ", " << r << " : " << Query(st, l, r + 1, n) << "\n";

    return 0;

}
