#include <fstream>
#include <algorithm>
#include <vector>
#include <tuple>
using namespace std;

ifstream fin("is.in");
ofstream fout("is.out");

const int MAX_N = 1e5,
          MAX_X = 3e5 + 5;

struct Event {
    int x, y1, y2, sgn;
    bool operator < (const Event& e) const
    {
		return x < e.x || (x == e.x && sgn > e.sgn);
	}
};

vector<Event> events;     // retine capetele (stanga si dreapta) a segm. orizontale si segmentele verticale
int st[4 * (2 * MAX_X)];  // st[nod] = nr de intersectii in intervalul de ORDONATE [l, r]  (pe axa OY)
long long cnt;            // coordonate negative: translatam cu 1e6 sa devina pozitive

long long Query(int x, int l, int r, int a, int b)
{
   if (a <= l && r <= b)  // recompun [a, b] din intervale [l, r] din arbore
       return st[x];      // ies, pt ca interv atasate fiilor nu mai pot aduce alte intevale pt completarea lui [a, b]
	
    int m;
    long long sum = 0;   
	m = (l + r) / 2;
	
    if (a <= m) 
		sum += Query(2 * x, l, m, a, b);
    if (b > m)  
		sum += Query(2 * x + 1, m + 1, r,  a, b);
    return sum;
}

void Update(int x, int l, int r, int p, int v) // v trebuie adaugat in toate intervalele care-l contin pe p
{
    int m = (l + r) / 2;

    st[x] += v;
    if (l == r) return;   // updatez inclusiv frunza care e intervalul[p,p]
    if (p <= m)           // p apartine sigur intervalului [l,m]
       Update(2 * x, l, m, p, v); // drumul spre frunza e unic, deci else
    else
       Update(2 * x + 1, m + 1, r, p, v);
}

int main()
{
    int n, x1, y1, x2, y2;
	
    fin >> n;             // nr segmente
    for (int i = 0; i < n; i++)
    {
     	fin >> x1 >> y1 >> x2 >> y2;    // in sirul de evenimente plasam si puncte si segmente :
     	                                                 
      	if (y1 == y2)     // orizontal   
      	{    
			events.push_back({x1, y1, 0, 1});  // sgn = +1 capat stanga seg, orizontal
			events.push_back({x2, y1, 0, -1}); // sgn = -1 capat dreapta
		} 
		else  
			if (x1 == x2)    // vertical
				events.push_back({x1, y1, y2, 0});
    }
   
    sort(events.begin(), events.end()); // sorteaza evenimentele dupa x, apoi dupa sgn: 
                                       // la acelasi x: sorteaza dupa capat stanga, segm vertical, capat dreapta 
    int sgn;
    for (auto event : events)
    {
		y1 = event.y1;
		y2 = event.y2;
		sgn = event.sgn;
		if (sgn == 0)       // segm vertical
		   cnt += Query(1, 0, 2 * MAX_X, y1 + MAX_X, y2 + MAX_X); // nr de intersectii ale lui cu segm orizontale
		else
		   Update(1, 0, 2 * MAX_X, y1 + MAX_X, sgn); // introduce (sgn = +1) sau scoate (sgn = -1) un capat de segm orizontal in arbore 
	}
    fout << cnt;
   
    return 0;
}


